package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.UserBalanceInMerchantService;
import com.gxwebsoft.shop.entity.UserBalanceInMerchant;
import com.gxwebsoft.shop.param.UserBalanceInMerchantParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 用户在商家中的余额控制器
 *
 * @author 科技小王子
 * @since 2024-11-20 01:55:04
 */
@Api(tags = "用户在商家中的余额管理")
@RestController
@RequestMapping("/api/shop/user-balance-in-merchant")
public class UserBalanceInMerchantController extends BaseController {
    @Resource
    private UserBalanceInMerchantService userBalanceInMerchantService;

    @PostMapping("/data")
    public ApiResult<UserBalanceInMerchant> data(@RequestBody UserBalanceInMerchantParam param) {
        // 使用关联查询
        return success(userBalanceInMerchantService.getBalance(param.getMerchantId(), getLoginUserId()));
    }

    @ApiOperation("分页查询用户在商家中的余额")
    @GetMapping("/page")
    public ApiResult<PageResult<UserBalanceInMerchant>> page(UserBalanceInMerchantParam param) {
        // 使用关联查询
        return success(userBalanceInMerchantService.pageRel(param));
    }

    @ApiOperation("查询全部用户在商家中的余额")
    @GetMapping()
    public ApiResult<List<UserBalanceInMerchant>> list(UserBalanceInMerchantParam param) {
        // 使用关联查询
        return success(userBalanceInMerchantService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userBalanceInMerchant:list')")
    @ApiOperation("根据id查询用户在商家中的余额")
    @GetMapping("/{id}")
    public ApiResult<UserBalanceInMerchant> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(userBalanceInMerchantService.getByIdRel(id));
    }

    @ApiOperation("添加用户在商家中的余额")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserBalanceInMerchant userBalanceInMerchant) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         userBalanceInMerchant.setUserId(loginUser.getUserId());
        }
        if (userBalanceInMerchantService.save(userBalanceInMerchant)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改用户在商家中的余额")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserBalanceInMerchant userBalanceInMerchant) {
        if (userBalanceInMerchantService.updateById(userBalanceInMerchant)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除用户在商家中的余额")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userBalanceInMerchantService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加用户在商家中的余额")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserBalanceInMerchant> list) {
        if (userBalanceInMerchantService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改用户在商家中的余额")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserBalanceInMerchant> batchParam) {
        if (batchParam.update(userBalanceInMerchantService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除用户在商家中的余额")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userBalanceInMerchantService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
